controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use app\models\Noticias;
use yii\data\ActiveDataProvider;
use app\models\Comentarios;
use app\models\NoticiasFotos;
use yii\helpers\ArrayHelper;
use yii\helpers\Html;
use app\models\SubirFotosForm;
use app\models\Fotos;
use yii\web\UploadedFile;
class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
        'query' => Noticias::find()]);
        return $this->render("index",["dataProvider" => $dataProvider]);
         
    }
    
    public function actionAnadircomentario($codigo)
    {
        $model = new Comentarios();

        if ($model->load(Yii::$app->request->post())) {
            $model->noticias_codigo=$codigo;
            $fecha=date('Y-m-d');
            $model->fecha=$fecha;
            if ($model->save()) 
            {
                return $this->redirect(["site/vercomentarios","codigo"=>$codigo]);
            }
        }

        return $this->render('formulario', [
            'model' => $model,
        ]);
    
    }
    
    public function actionVercomentarios($codigo)
    {
        $noticia= Noticias::findOne($codigo);
        $dataProvider = new ActiveDataProvider([
        'query' => Comentarios::find()->where(['noticias_codigo' => $codigo])]);
        return $this->render("listar",["dataProvider" => $dataProvider,"noticia" => $noticia]);
    }
    
    public function actionEditarcomentario($codigo)
    {
        $model=Comentarios::findOne($codigo);
        
        if($this->request->isPost)
        {
            if ($model->load(Yii::$app->request->post())) {
                if ($model->save()) 
                {
                    return $this->redirect(["site/vercomentarios","codigo"=>$model->noticias_codigo]);
                }
            }
        }
        
        return $this->render('formulario', [
            'model' => $model,
        ]);
                
    }
    
    public function actionEliminarcomentario($codigo)
    {
        $model=Comentarios::findOne($codigo);
        $noticias_codigo=$model->noticias_codigo;
        $model->delete();
        return $this->redirect(["site/vercomentarios","codigo"=>$noticias_codigo]);
    }
    
    public function actionNuevanoticia()
    {
        $model=new Noticias();
        
        
        if($datos=Yii::$app->request->post())
        {
            $model->titulo=$datos["titulo"];
            $model->texto=$datos["texto"];
            $model->fecha=$datos["fecha"];
            $model->save();
            $ultima_noticia= Noticias::find("codigo")->orderBy("codigo DESC")->one();
            foreach($datos["fotos"] as $foto)
            {
                $model_2=new NoticiasFotos();
                $model_2->noticias_codigo=$ultima_noticia->codigo;
                $model_2->fotos_codigo=$foto;
                $model_2->save();
            }
            return $this->redirect(["site/index"]);
            
        }else
        {
            return $this->render("formulario_noticias2");
        }
    }
    
    public function actionFormulario1()
    {
        if($datos=Yii::$app->request->post())
        {
            var_dump($datos);
            
        }else
        {
            return $this->render("formulario_noticias2");
        }
    }
    
    public function actionEditarnoticia($codigo)
    {
        $model= Noticias::findOne($codigo);
        
        if ($model->load(Yii::$app->request->post())) 
        {
            if ($model->validate()) {
                $model->save();
                return $this->redirect(["site/index"]);
                }
        }

        return $this->render('formulario_noticias', [
            'model' => $model,
        ]);
    }
    
    public function actionEliminarnoticia($codigo)
    {
        $model=Noticias::findOne($codigo);
        $model->delete();
        return $this->redirect(["site/index"]);
    }
    
    public function actionConfirmareliminarnoticia($codigo)
    {
        $model=Noticias::findOne($codigo);
        
        return $this->render("ver",['model'=> $model]);
    }
    
    public function actionAnadirfotos()
    {
        $model=new SubirFotosForm();
        $mensaje=null;
        $imagen_repetida=null;
        
        if ($model->load(Yii::$app->request->post()))
    {
     $model->imagenes = UploadedFile::getInstances($model, 'imagenes');

     if ($model->imagenes && $model->validate()) 
     {
         $imagenes_bd= Fotos::find()->asArray()->all();
         $imagenes_bd= ArrayHelper::getColumn($imagenes_bd,"nombre");
        foreach ($model->imagenes as $imagen) 
        {   
            foreach($imagenes_bd as $imagen_bd)
            {
                if($imagen->name==$imagen_bd)
                {
                    $imagen_repetida=$imagen->name;
                    break;
                }
            }

            if($imagen_repetida==null)
            {
                $imagen->saveAs('imgs/' . $imagen->name);
                $mensaje = "<p><strong class='label label-info'>Enhorabuena, subida realizada con éxito</strong></p>";
                $foto=new Fotos;
                $foto->nombre=$imagen->name;
                $foto->save();
            }else
            {
                $mensaje = "<p><strong class='label label-info'>Error, ya existe una imagen llamada $imagen_repetida</strong></p>";
                break;
            }

        }
     }
    }
    return $this->render("formulario_fotos", ["model" => $model, "mensaje" => $mensaje]);
    }
    
    public function actionListarfotos()
    {
         $dataProvider = new ActiveDataProvider([
        'query' => Fotos::find(),
             'pagination' => ['pageSize' => 6]
             ]);
        return $this->render("listarfotos",["dataProvider" => $dataProvider]);
    }
    
    public function actionEliminarfoto($codigo)
    {
        $imagen= Fotos::findOne($codigo);
        unlink("../web/imgs/" . $imagen->nombre);
        $imagen->delete();
        return $this->redirect(["site/listarfotos"]);
    }

}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header>
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'items' => [
            ['label' => 'Noticias', 'url' => ['/site/index']],
            ['label' => 'Fotos', 'items' =>[
                ['label' => 'Añadir Fotos', 'url' => ['/site/anadirfotos']],
                ['label' => 'Eliminar Fotos', 'url' => ['/site/listarfotos']]]],
        ],
    ]);
    NavBar::end();
    ?>
</header>

<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer class="footer mt-auto py-3 text-muted">
    <div class="container" style="color: black">
        <div class="row">
            <div class="col-md-4"><h4>DATOS DE CONTACTO</h4>
                <ul style="list-style:none">
                    <li><h6><b>Diego`s Company</b></h6></li>
                    <li><h6><b>942784653</b></h6></li>
                    <li><h6><b>diego@gmail.com</b></h6></li>
                </ul>
            </div>
            <div class="col-md-4"><h4>REDES SOCIALES</h4>
                    <a href="https://www.facebook.com/MarketingTCM/" style="float:left;"><h1><i class="fab fa-facebook-square"></i>&nbsp;</h1></a>
                    <a href="https://www.instagram.com/marketing_tcm/" style="float:left;"><h1><i class="fab fa-instagram-square"></i>&nbsp;</h1></a>
                    <a href="https://www.youtube.com/channel/UClERLxGKsbQqKoX7-Y_IMGw" ><h1><i class="fab fa-youtube-square"></i></h1>&nbsp;</a>
            </div>
            <div class="col-md-4"><h4>DESCARGAR APP</h4>
                <a href="https://play.google.com/store/apps/details?id=com.marketingtcm.marketingtcm"><h1 style="float:left;"><i class="fab fa-google-play"></i>&nbsp;</h1><h2>Google Play</h2></a>
            </div>
        </div>
        <p class="float-left">My Company</p>
        <p class="float-right"><?= Yii::powered() ?></p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>